﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_explicit_interface
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Make some Persons.
            Person person1 = new Person();
            Person person2 = new Person();
            int result;

            // Not allowed.
            //result = person1.CompareTo(person2);

            // Allowed.
            result = ((IComparable<Person>)person1).CompareTo(person2);

            // Allowed.
            IComparable<Person> comparable = (IComparable<Person>)person1;
            result = comparable.CompareTo(person2);

            // Fails at run time.
            //IComparable comparable2 = (IComparable)person1;
            //result = comparable2.CompareTo(person2);

            // Sort some Persons.
            Person[] people =
            {
                new Person() { FirstName = "Dan", LastName = "Deevers"},
                new Person() { FirstName = "Bob", LastName = "Baker"},
                new Person() { FirstName = "Cat", LastName = "Carter"},
                new Person() { FirstName = "Ann", LastName = "Archer"},
            };
            Array.Sort(people);
            lstPeople.DataSource = people;
        }
    }
}
